BEGIN TRANSACTION;
CREATE TABLE users (
    id INTEGER PRIMARY KEY,
    user_token TEXT UNIQUE NOT NULL
);
CREATE TABLE errors (
    id INTEGER PRIMARY KEY,
    error TEXT NOT NULL,
    description TEXT NOT NULL
);
CREATE TABLE errors_javac_regexp (
    id INTEGER PRIMARY KEY,
    regexp TEXT UNIQUE NOT NULL,
    error_id INTEGER NOT NULL,
    handler TEXT,
    CONSTRAINT error_javac_regexp_error_fk FOREIGN KEY ( error_id ) REFERENCES errors ( id )
);
CREATE TABLE errors_javac_tokens (
    id INTEGER PRIMARY KEY,
    etoken TEXT UNIQUE NOT NULL,
    error_id INTEGER NOT NULL,
    handler TEXT,
    CONSTRAINT error_javac_tokens_error_fk FOREIGN KEY ( error_id ) REFERENCES errors ( id )
);
CREATE TABLE errors_yacc (
    id INTEGER PRIMARY KEY,
    etoken TEXT UNIQUE NOT NULL,
    error_id INTEGER NOT NULL,
    CONSTRAINT error_yacc_error_fk FOREIGN KEY ( error_id ) REFERENCES errors ( id )
);
CREATE TABLE checks (
    id INTEGER PRIMARY KEY,
    user_id INTEGER,
    date TEXT,
    source TEXT,
    ip TEXT,
    CONSTRAINT check_user_fk FOREIGN KEY ( user_id ) REFERENCES users ( id )
);
CREATE TABLE check_errors (
    check_id INTEGER NOT NULL,
    error_id INTEGER NOT NULL,
    date TEXT,
    source_line TEXT NOT NULL,
    CONSTRAINT check_error_check_fk FOREIGN KEY ( check_id ) REFERENCES checks ( id ),
    CONSTRAINT check_error_error_fk FOREIGN KEY ( error_id ) REFERENCES errors ( id )
);
COMMIT;
