package yacc;

use strict;
use warnings;
require "backends/yacc/Lexer.pm";
require "backends/yacc/Parser.pm";
require "backends/yacc/Errors.pm";
use vars qw/@ISA @EXPORT/;
require Exporter;

@ISA = qw/Exporter/;
@EXPORT = qw/checkSources/;

sub checkSources {
    my $source = shift;
    my $parser = new Parser;

    # Give the lexer our source
    # Turns out Perl supports stringrefs as arguments to open()
    Lexer::lexOpen( \$source );

    # Parse the class which is in this file
    $parser -> YYParse ( yylex => \&Lexer::Lexer, yyerror => \&Lexer::_Error,
#		 yydebug => 0x1F
    );

    # Close the lexer
    Lexer::lexClose();

    return Errors::getErrors();
}

1;
