#!/usr/bin/perl
use strict;
use warnings;
use lib '..';
use Arjen;
use JSON;
use CGI;
use XML::Writer;

my $q = CGI -> new;

print $q -> header ( 'text/xml' );

my $utoken = $q -> url_param ( 'user' ) or undef;
my $storeSource = $q -> url_param ( 'source' ) or undef;

$utoken =~ s/(^\s*|\s*$)// if $utoken;
$utoken = undef if not $utoken or $utoken eq "";
my $errors = checkSource ( $q -> param ( 'POSTDATA' ), $utoken, $storeSource, $ENV{"REMOTE_ADDR"} );

my $xml = new XML::Writer(); # Write to STDOUT
$xml -> startTag ( 'errors' );
foreach my $error ( @{ $errors } ) {
    $xml -> startTag ( 'error',
        line => $error -> { "line" },
        title => $error -> { "error" }
    );
    $xml -> cdataElement ( 'description', $error -> { "description" } );
    $xml -> endTag ( 'error' );
}
$xml -> endTag ( 'errors' );

exit 0;
