#!/usr/bin/perl
use strict;
use warnings;
use YAML qw/LoadFile/;

die "Usage: $0 <dirname>\n" if @ARGV != 1;
opendir my $ERRORS, $ARGV[0];
my $i = 1;
while ( $_ = readdir $ERRORS ) {
    next if not /\.yaml$/; 
    my $e = YAML::LoadFile ( $ARGV[0] . "/" . $_ );
    esc ( $e -> { "title" } );
    esc ( $e -> { "description" } );
    print "INSERT INTO errors ( id, error, description ) VALUES ( $i, '" . $e -> { "title" } . "', '" . $e -> { "description" } . "' );\n"; 
    if ( defined $e -> { "tokens" } ) {
        foreach my $token ( @{ $e -> { "tokens" } } ) {
            esc ( $token -> { "token" } );
            if ( defined $token -> { "handler" } ) {
                esc ( $token -> { "handler" } );
                print "INSERT INTO errors_javac_tokens ( error_id, etoken, handler ) VALUES ( $i, '" . $token -> { "token" } . "', '" . $token -> { "handler" } . "' );\n";
            } else {
                print "INSERT INTO errors_javac_tokens ( error_id, etoken, handler ) VALUES ( $i, '" . $token -> { "token" } . "', NULL );\n";
            }
        }
    }
    if ( defined $e -> { "regexp" } ) {
        foreach my $regexp ( @{ $e -> { "regexp" } } ) {
            esc ( $regexp -> { "regexp" } );
            if ( defined $regexp -> { "handler" } ) {
                esc ( $regexp -> { "handler" } );
                print "INSERT INTO errors_javac_regexp ( error_id, regexp, handler ) VALUES ( $i, '" . $regexp -> { "regexp" } . "', '" . $regexp -> { "handler" } . "' );\n";
            } else {
                print "INSERT INTO errors_javac_regexp ( error_id, regexp, handler ) VALUES ( $i, '" . $regexp -> { "regexp" } . "', NULL );\n";
            }
        }
    }
    if ( defined $e -> { "yacc" } ) {
        foreach my $yacc ( @{ $e -> { "yacc" } } ) {
            esc ( $yacc -> { "token" } );
            print "INSERT INTO errors_yacc ( error_id, etoken ) VALUES ( $i, '" . $yacc -> { "token" } . "' );\n";
        }
    }

    $i++;
}
closedir $ERRORS;

sub esc {
    $_[0] =~ s/'/''/g;
}
