#!/usr/bin/perl
use strict;
use warnings;
use Arjen;
use Term::ReadKey;

my ($wchar, $hchar, $wpixels, $hpixels) = GetTerminalSize();

die("Usage: $0 javafile [userid]\n") if ((@ARGV < 1) || (@ARGV >2));

my $userid= $ARGV[1] || undef;

open(my $fh, "<", $ARGV[0]) || die("Can't open $ARGV[0]: $!\n");

my $errors = checkSource ( join ( "", <$fh> ), $userid );
close($fh);

my $termWidth = ( $wchar =~ /^\d+$/ ? $wchar : 35 );
foreach my $error ( @{ $errors } ) {
    printf "\nLine %05d: %s\n", $error -> { "line" }, $error -> { "error" };
    print "-" x $termWidth;
    printf "\n%s\n", $error -> { "description" };
}

exit 0;
